/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab3.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
********************************************************************************/
#include <p18cxxx.h>
#include "P18F_LCD.h"
#include <stdlib.h>
#include <timers.h>

#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	LED		LATD					// PORTD s 8  LEDs
#define	SW2		PORTBbits.RB0        	// ϥ p18f4520.h  PORTB 줸cwq
#define SW3		PORTAbits.RA4
#define	TIMER1_5mS_VALUE 	65536-(5000*2)+96	// CPU runs @ 8Mhz , 2MHZ Fcy , 5ms = 10000 Fcy
												// 96 O_ήɶs Timer1 ץ,
												// ץȬO MPLAB SIM + Stopwatch ҺXӪ
//********* ƪ쫬ŧi **********
//
void	IntHighVector(void);
void 	HighISR(void) ;									
void 	IO_Initial(void );
void 	Timer1_Initial(void);
void 	Key_Detecting(void );
void 	LCD_Update( void);
void 	MS_Delay(void);

//*********** ܼƩwq  *************
//
unsigned char	Key_Input = 0 ;
unsigned char	Bounce_Count = 0 ;
unsigned char	SW2_Count = 0 ;
unsigned char	SW3_Count = 0 ;
unsigned int	Delay_X ;
unsigned char 	LED_Delay_Count;
char			ASCII_Buffer[10] ;

//******** uv_{iJI  ******
//
#pragma	code	HighVector = 0x0008 
void	IntHighVector(void)
{
	_asm	goto	HighISR		_endasm
}	
#pragma code

//******** uv_  ***********
//
#pragma	interrupt HighISR
void	HighISR(void)
{
	if (PIR1bits.TMR1IF)
	{
		PIR1bits.TMR1IF = 0 ;
		WriteTimer1(TIMER1_5mS_VALUE);
		Key_Detecting( );
	}
}
#pragma code

//*******************************************
//****************  D{  ***************** 
//*******************************************
//
void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// Select INTOSC-8Mhz as clock source
									// ToDo : iHվ IRCF 줸ӳ]wu@Wv 

	RCONbits.IPEN=1;				// }lBCuv_\
	IPR1bits.TMR1IP=1;				// ]w Timer1 uv_
	INTCONbits.GIEH = 1 ;			// }Ұץv_

	IO_Initial( );
	Timer1_Initial( );
    OpenLCD();

    putrsLCD((const rom far char*)" Lab3 Interrupt  ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const rom far char*)"SW3=0   ;SW2=0  ");

    while(1)
	{
		LCD_Update( );
	}
}


//
// ******  I/O }XJ]w ADC J\  ******
//
void IO_Initial(void )
{
	ADCON1bits.PCFG = 0x0F ;
	LATD = 0x00 ;					// Turn Off all LEDs
	TRISD = 0x00;   
	TRISAbits.TRISA4 = 1;
	TRISBbits.TRISB0 = 1;
}

//
//***** ]w Timer1 l{
//
void Timer1_Initial(void)
{
	WriteTimer1(TIMER1_5mS_VALUE);
	OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW &\
   			    T1_SOURCE_INT & T1_PS_1_1 & \
				T1_OSC1EN_OFF & T1_SYNC_EXT_OFF ) ;
}

//
//   SW2 & SW3 O_s䪺JApsʧ@h]w
//  ۹諸XAѥD{Bzץ󪺤u@C
//
//  BzuD,C 5mS @@ 10 
//
void Key_Detecting(void)
{
	if (Bounce_Count==0)				// Ҧ䪺uBz?
	{
		if (!SW2)						//  S2 O_U?
		{
			Bounce_Count=10; 			// S2 UA]wu 10
			SW2_Count++;
			Key_Input = 0x01;			// ]wJAX = 0x01
		}  
		if (!SW3)						//  S3 O_U?
		{
			Bounce_Count=10; 
			SW3_Count++;
			Key_Input = 0x02;
		}  
	}  
	else								// Bzu
	{
		if ( SW2 && SW3)	
			Bounce_Count --;  			// S2 & S3 䳣}F? O: uˬdƴ@
		else Bounce_Count = 10;			// SA٦QA]uˬd 10 
	}
	    

}

void LCD_Update(void)
{
	if (Key_Input == 0x02)
	{
		Key_Input = 0;							// M SW3 䪬A

		LCD_Set_Cursor(1,4);					// M LCD nܪ
		putrsLCD((const rom far char*)"    ");			

		LCD_Set_Cursor(1,4);				 	//	]w (Y,X)
		itoa(SW3_Count,ASCII_Buffer) ;     		// itoa( )  10 iAন ASCII Code rꫬA
		putsLCD(ASCII_Buffer) ;					// LXnr LCD W
	}

	if (Key_Input == 0x01)
	{
		Key_Input = 0;							// M SW2 䪬A

		LCD_Set_Cursor(1,13);
		putrsLCD((const rom far char*)"   ");			

		LCD_Set_Cursor(1,13);					//	]w (Y,X)
		itoa(SW2_Count,ASCII_Buffer) ;     		// itoa( ) Ʀ\? qBo?
		putsLCD(ASCII_Buffer) ;
	}	
}	
