#include "main.h"

//************************************************
//* PIC18F4520 b ADC Peripheral Library k  *
//*  V5 , bϥ OpenADC() ɭnѦ 			 *
//* Function: InitializeAD                       *
//*        - Fosc/32 clock source                *
//*        - Right justified                     *
//*        - 1 analog channels, 0 references     *
//*        - Channel 0                           *
//*        - Disable A/D interrupt               *
//************************************************
void InitializeAD(void)
{
	OpenADC(  ADC_FOSC_32
			& ADC_RIGHT_JUST 
			& ADC_4_TAD,
			  ADC_CH1 
			& ADC_INT_OFF
			& ADC_REF_VREFPLUS_VSS,  // ϥΥ~ 3.3V ѦҹqA AN3 }J
			  ADC_1ANA);
}

//************************************************
//* Initial I2C Master Mode with 7 bits Address  *
//* Clock Speed : 100KHz @16MHz					 *
//************************************************
void Initialize_I2C_Master(void)
{
	TRISCbits.TRISC3=1;
	TRISCbits.TRISC4=1;
	OpenI2C(MASTER,SLEW_ON);
	SSPADD= 39;
	SSPSTATbits.CKE=1;				// SMBus specific inputs
} 

//************************************************
//* Function: Initialize Interrupts              *
//*   - Reset All Interrupr                      *
//*   - Enable HIgh Priority Interrupt           *
//*   - Disable Low Priority Interrupt           *
//************************************************
void InitializeINTs(void) 
{
 	PIR1=0; 						//Clear all Interrupt setting & Flag
	PIR2=0;
	INTCON=0;
	INTCON2=0;
	INTCON3=0;
	PIE1=0;
	PIE2=0;

	RCONbits.IPEN=1;     			//Enable priority interrupts
	INTCONbits.GIEL=1;				// Enable Low Priority Interrupt
	INTCONbits.GIEH=1;				// Enalbe high priority Interrupt
}

//************************************************
//*        Function: Initialize Timer1           *
//************************************************
void InitializeTMR1(void)
{
//
//  d PIC18F4520 PƮwϥλA]w Timer1 u@Ҧ
//  ҥTimer12u uv_ATimer1  16-bit ҦAϥΥ~_
//  w 1:1AҥΥ~_ADPBpƼҦ
//	]w Timer1 ϥΥ~ 32768Hz _ò 0.5
//
//???	OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW
//???					& ??? & T1_PS_1_1
//???					& ??? & T1_SYNC_EXT_ON);
	
//??? 	WriteTimer1(??? ) ;

//???	IPR1bits.TMR1IP=0;						// Set Timer1 for Low Priority Interrupt
	PIR1bits.TMR1IF=0;						// Clear Interrupt flag of Timer 1
	
	PIE1bits.TMR1IE=1;						// Enable Timer1 Interrupt
}


//************************************************
//*        Function: Initialize PORT             *
//************************************************
void InitializePORT(void)
{
	ADCON1=0b00000101;    			// Enable AN0 & AN1 with External Vref
	PORTA=0x00;
	TRISA=0b11011011;				// RA0 & RA1 as A/D input,RA4 as SW2 input
									// RA2 as LCD-E control, RA5 as CS Control  for SPI
	PORTB=0x00;
	TRISB=0b11001001;				// RB[6:7] as ICD2, 
									// RB2 as CANTX , RB3 as CANRX
	PORTC=0x00;
	
	PORTD=0x00;
}
